<template>
  <v-col cols="12" xs="12" class="px-0 pb-0">
    <v-form v-model="valid" @submit.prevent="onSubmit">
      <v-row align="center" class="justify-space-between d-flex mb-5">
        <v-col cols="6">
          <h2 class="info-porta_title text-left">
            {{ isRegister ? $t('sessionregister') : $t('confirmData') }}
          </h2>
        </v-col>
        <template v-if="autenticar">
          <v-col cols="6" xl="6" class="text-right">
            <h4 class="color-primary">
              CUIL/CUIT:
              <span class="subtitle-1 black--text">{{
                dataToRegister.dni
              }}</span>
            </h4>
          </v-col>
        </template>
      </v-row>
      <v-row>
        <v-col cols="12" md="6" class="pb-0">
          <v-text-field
            id="first-name"
            v-model="dataToRegister.first_name"
            class="pb-2"
            :label="$t('name')"
            :rules="rules"
            outlined
            required
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6" class="pb-0">
          <v-text-field
            id="last-name"
            v-model="dataToRegister.last_name"
            class="pb-2"
            :label="$t('lastname')"
            :rules="rules"
            required
            outlined
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" class="py-0">
          <v-text-field
            id="email"
            v-model="dataToRegister.email"
            class="pb-2"
            :label="$t('email')"
            :rules="emailRules"
            oncopy="return false;"
            oncut="return false;"
            onpaste="return false;"
            required
            outlined
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" class="py-0">
          <v-text-field
            id="confirmEmail"
            v-model="confirmEmail"
            class="pb-2"
            :label="$t('confirmEmail')"
            :rules="emailRules.concat(validEmail)"
            required
            outlined
            onpaste="return false;"
            autocomplete="off chrome-off false"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" class="py-0">
          <v-text-field
            id="password"
            v-model="dataToRegister.password"
            :append-icon="showPassword ? 'mdi-eye-off' : 'mdi-eye'"
            :type="showPassword ? 'text' : 'password'"
            :label="$t('password')"
            :rules="rules"
            required
            outlined
            @click:append="showPassword = !showPassword"
          >
          </v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" class="py-0">
          <v-text-field
            id="confirmPassword"
            v-model="confirmPassword"
            :append-icon="showConfirmPassword ? 'mdi-eye-off' : 'mdi-eye'"
            :type="showConfirmPassword ? 'text' : 'password'"
            :label="$t('confirmPassword')"
            :rules="rules.concat(validPassword)"
            required
            outlined
            @click:append="showConfirmPassword = !showConfirmPassword"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" class="py-0">
          <v-checkbox
            v-model="checkbox"
            :label="$t('confirmDataRegister')"
          ></v-checkbox>
        </v-col>
      </v-row>
      <v-row v-if="autenticar" class="pb-10">
        <v-col cols="12" class="py-0">
          <v-btn
            id="save-user"
            :disabled="disabledForm"
            block
            type="submit"
            color="primary"
            class="white--text"
          >
            <v-progress-circular
              v-if="loading"
              indeterminate
              color="primary"
            ></v-progress-circular>
            <template v-else>{{ $t('next') }}</template>
          </v-btn>
        </v-col>
      </v-row>
      <v-row
        v-if="isRegister && !$store.getters['loggedIn']"
        justify="center"
        class="my-5"
      >
        <v-col cols="12" class="py-0">
          <div :id="captcha" class="recaptcha"></div>
        </v-col>
      </v-row>
    </v-form>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-col>
</template>
<script lang="ts">
import Vue from 'vue'
import _ from 'lodash'
import { mapGetters } from 'vuex'

declare global {
  interface Window {
    recaptchaVerifierRegisterEmail: any
    recaptchaWidgetRegisterId: any
  }
}

export default Vue.extend({
  name: 'ArgRegister',
  props: {
    captcha: {
      type: String,
      default: '',
    },
    isRegister: {
      type: Boolean,
      default: false,
    },
    loading: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      showPassword: false,
      showConfirmPassword: false,
      valid: false,
      reCAPTCHARegisterEMAIL: false,
      rules: [(v: any) => !!v || 'Campo requerido'],
      rulesNumber: [
        (v: number) => !!v || 'El campo es requerido o número inválido',
        (v: number) => !(v < 0) || 'El numero no puede ser menor que 0',
      ],
      emailRules: [
        (v: string) => !!v || 'El campo es requerido',
        (v: string) =>
          !v ||
          /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i.test(v) ||
          'Ingresa un email válido',
      ],
      dataToRegister: {
        first_name: '',
        last_name: '',
        email: '',
        password: '',
        dni: '',
        public_address: '',
      },
      confirmPassword: '',
      confirmEmail: '',
      checkbox: false,
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
    }
  },
  computed: {
    ...mapGetters({
      user: 'users/user',
      autenticarUser: 'autenticarUser',
      autenticar: 'authconfig/autenticar',
    }),
    validPassword(): any {
      return (
        this.dataToRegister.password === this.confirmPassword ||
        'Las contraseñas no coinciden.'
      )
    },
    validEmail(): any {
      return (
        this.dataToRegister.email === this.confirmEmail ||
        'Los emails no coinciden.'
      )
    },
    disabledForm(): any {
      return !this.valid || !this.checkbox || this.loading
    },
  },
  watch: {
    disabledForm(val): any {
      if (this.isRegister) {
        this.$emit('valid', !val)
        this.$emit('data', this.dataToRegister)
      }
    },
  },
  mounted() {
    if (this.$store.getters.loggedIn) {
      if (this.user) {
        this.dataToRegister = _.merge(this.dataToRegister, this.user)
      } else if (this.autenticarUser) {
        this.dataToRegister = _.merge(this.dataToRegister, this.autenticarUser)
      }
      this.dataToRegister.dni = this.dataToRegister.dni
        ? this.dataToRegister.dni
        : this.$fire.auth.currentUser.uid
    }
    this.loadRecaptcha()
  },
  methods: {
    loadRecaptcha() {
      if (this.isRegister && !this.$store.getters.loggedIn) {
        const self = this
        window.recaptchaVerifierRegisterEmail =
          new self.$fireModule.auth.RecaptchaVerifier(this.captcha, {
            callback() {
              // eslint-disable-next-line @typescript-eslint/no-unused-vars
              return new Promise<string | void>((resolve, reject) => {
                self.reCAPTCHARegisterEMAIL = true
                resolve()
              })
            },
            'expired-callback': () => {
              // eslint-disable-next-line @typescript-eslint/no-unused-vars
              return new Promise<string | void>((resolve, reject) => {
                self.reCAPTCHARegisterEMAIL = false
              })
            },
            size: this.$vuetify.breakpoint.smAndDown ? 'compact' : 'normal',
          })
        window.recaptchaVerifierRegisterEmail
          .render()
          .then(function (widgetId: any) {
            window.recaptchaWidgetRegisterId = widgetId
          })
      }
    },
    onSubmit() {
      this.dataToRegister.dni = this.dataToRegister.dni
        ? this.dataToRegister.dni
        : this.$fire.auth.currentUser.uid
      this.$emit('valid', this.valid)
      this.$emit('data', this.dataToRegister)
    },
  },
})
</script>

<style scoped>
.g-recaptcha-response {
  width: 100%;
  border-radius: 4px;
  border-right: 1px solid #d8d8d8;
  overflow: hidden;
}
.recaptcha {
  width: 100%;
}
.color-primary {
  color: var(--v-primary-base);
}
</style>
